#ifndef GRAPHICS_MODES
# define GRAPHICS_MODES
# define VGA 1
# define EGA 2
# define CGA 4

typedef unsigned int * Tile;
typedef struct {
  Tile * tiles;
  unsigned int count;
  unsigned int tilesize;
} Tileset;
typedef unsigned int MapTile;
typedef struct {
  MapTile * tiles;
  unsigned int width;
  unsigned int height;
} Map;

unsigned int getCGAPixel(unsigned char byte, int offset);
unsigned int getEGAPixel(unsigned char byte, int offset);

Tile getTile(const char * filecontents, const unsigned int offset,
    const unsigned short int gfxmode, const unsigned short int tilesize = 16);
Tile getTile(const Tileset tileset, const unsigned int offset,
    const unsigned short int gfxmode, const unsigned short int tilesize = 16);
Tileset getTileset(const char * filename, const unsigned short int gfxmode,
    const unsigned short int tilesize = 16);

Map loadMap(const char * filename, unsigned int width, unsigned int height);

#endif
